PDF pdf;

int width = 595;
int height = 842;

float c = 0;
float m = 0;
float y = 0;
float k = 0;

float step = 0.25;
int rectSize = width/10;
int rectx = 0;
int recty = 0;

char[] chars = {'C', 'M', 'Y', 'K', '0','1','2','3','4','5','6','7','8','9'};
float fontSize = 12;

int t;


float x1, x2, y1, y2, r1, r2;
CMYKColor c1, c2;

void setup() {
  t = millis();
  
//  pdf = new PDF(this, mm(210), mm(297), sketchPath(System.currentTimeMillis() + ".pdf"));  
  pdf = new PDF(this, width, height, sketchPath(System.currentTimeMillis() + ".pdf"));  
  pdf.textFont(createFont("Courier New", fontSize, true, chars));
  
  cycle();
  lastPage();
  
  pdf.dispose();
  exit();

}

void cycle() {

  for(int k = 0; k<=100; k++ ) {
         c1 = new CMYKColor(random(1f), random(1f), random(1f), random(0f));
         c2 = new CMYKColor(random(1f), random(1f), random(1f), random(0f));

          x1 = random(width);
          x2 = random(width);
          y1 = random(height);
          y2 = random(height);
          r1 = random(height);
          r2 = random(height);


          pdf.noStroke();
          //pdf.radialGradient(width/2, height/2, random(width), width/2, height/2, random(width), c1, c2);
          pdf.radialGradient(x1, y1, r1, x2, y2, r2, c1, c2, false, false);
          pdf.rect(0, 0, width, height);
          
          pdf.noFill();
          pdf.ellipseMode(RADIUS);
          pdf.strokeCMYK(0,0,0,0);
          pdf.ellipse(x1, y1, 2, 2);
          pdf.ellipse(x2, y2, 2, 2);
          pdf.ellipse(x1, y1, r1, r1);
          pdf.ellipse(x2, y2, r2, r2);
          
         //c1 = c2;
         //c2 = c1;          
          //pdf.noStroke();
          //pdf.radialGradient(x1, y1, r1, x2, y2, r2, c1, c2, true, true);
          //pdf.triangle(random(width), random(height), random(width), random(height), random(width), random(height));

          
          int x1offset = 30; //(x1 > (width/2)) ? -30: 30;
          int y1offset = 30; //(y1 > (height/2)) ? -30: 30;
          int x2offset = 30; //(x2 > (width/2)) ? -30: 30;
          int y2offset = 30; //(y2 > (height/2)) ? -30: 30;
          
          
          pdf.line(x1, y1, (x1+x1offset), (y1+y1offset));      
          pdf.line(x2, y2, (x2+x2offset), (y2+y2offset));      
          
          pdf.fillCMYK(0,0,0,0);
          pdf.pushMatrix();
          pdf.translate(x1+x1offset, y1+y1offset);
          pdf.textAlign(LEFT, TOP);
          pdf.textSize(12);
          pdf.text("C \t" +nf(int(c1.getCyan()*100), 3, 0), 0, 0);
          pdf.text("M \t" +nf(int(c1.getMagenta()*100), 3, 0), 0, 10);
          pdf.text("Y \t" +nf(int(c1.getYellow()*100), 3, 0), 0, 20);
          pdf.text("K \t" +nf(int(c1.getBlack()*100), 3, 0), 0, 30);    
          pdf.popMatrix();   

          pdf.pushMatrix();
          pdf.translate(x2 +x2offset, y2+y2offset);
          pdf.textAlign(LEFT, TOP);
          pdf.text("C \t" +nf(int(c2.getCyan()*100), 3, 0), 0, 0);
          pdf.text("M \t" +nf(int(c2.getMagenta()*100), 3, 0), 0, 10);
          pdf.text("Y \t" +nf(int(c2.getYellow()*100), 3, 0), 0, 20);
          pdf.text("K \t" +nf(int(c2.getBlack()*100), 3, 0), 0, 30);    
          pdf.popMatrix();  
          
          
          pdf.nextPage();
 
  }  
  
  
} 

void lastPage() {
  t = millis() - t;
  pdf.fillCMYK(0,0,0,1f);
  pdf.textAlign(LEFT, TOP);
  pdf.textSize(10);
  pdf.text("The generation of this document took " +((float)t/1000f) +" seconds.", 10, height-100);
}

public float mm(float pt) {
  return pt * 2.83464567f;
}

