PDF pdf;

int width = 595;
int height = 842;

float c = 0;
float m = 0;
float y = 0;
float k = 0;

float step = 0.01;
int rectSize = width/10;
int rectx = 0;
int recty = 0;
int rectPerPage = 15;
int rectCount = 0;
int textIndentX = 20;
int textIndentY = 3;

char[] chars = {'C', 'M', 'Y', 'K', '0','1','2','3','4','5','6','7','8','9'};
float fontSize = 14;
float lineHeight = 11;
int t;

void setup() {
  t = millis();
  
  pdf = new PDF(this, width, height, sketchPath(System.currentTimeMillis() + ".pdf"));  
  pdf.textFont(createFont("Courier New", fontSize));
  
  cycle();
  
  pdf.dispose();
  exit();

}


void cycle() {

  for(float k = 0; k<=1f; k+=step ) {
          
    pdf.noStroke();
    pdf.fillCMYK(c, m, y, k);
  
    float rh = height / rectPerPage;
    float ry = rh*rectCount;
    pdf.rect(0, ry, width, rh);
    
    pdf.fillK(1.0 - k);
    float textX = random(textIndentX, width-textIndentX-55);
    pdf.rect(textX-7, ry, 55, rh);
  
    pdf.fillK(k);
    pdf.textAlign(LEFT, TOP);
    pdf.text("C \t" +nf(c*100, 3, 0), textX, ry+textIndentY);
    pdf.text("M \t" +nf(m*100, 3, 0), textX, ry+textIndentY+lineHeight);
    pdf.text("Y \t" +nf(y*100, 3, 0), textX, ry+textIndentY+(2*lineHeight));
    pdf.text("K \t" +nf(k*100, 3, 0), textX, ry+textIndentY+(3*lineHeight));          
    
    rectCount++;
    if(rectCount >= rectPerPage) {
      rectCount = 0; 
      pdf.nextPage();
    }
  }  
} 

void lastPage() {
  t = millis() - t;
  pdf.fillCMYK(0,0,0,1f);
  pdf.textAlign(LEFT, TOP);
  pdf.textSize(10);
  pdf.text("The generation of this document took " +((float)t/1000f) +" seconds.", 10, height-100);
}

